﻿/****************** 
 * Hu4In1_On Test *
 ******************/


// store info about the experiment session:
let expName = 'hu4in1_on';  // from the Builder filename that created this script
let expInfo = {'participant': ''};

// Start code blocks for 'Before Experiment'
ax = 0;
ay = 0;
bx = 0;
by = 0;

// init psychoJS:
const psychoJS = new PsychoJS({
  debug: true
});

// open window:
psychoJS.openWindow({
  fullscr: true,
  color: new util.Color('white'),
  units: 'height',
  waitBlanking: true
});
// schedule the experiment:
psychoJS.schedule(psychoJS.gui.DlgFromDict({
  dictionary: expInfo,
  title: expName
}));

const flowScheduler = new Scheduler(psychoJS);
const dialogCancelScheduler = new Scheduler(psychoJS);
psychoJS.scheduleCondition(function() { return (psychoJS.gui.dialogComponent.button === 'OK'); }, flowScheduler, dialogCancelScheduler);

// flowScheduler gets run if the participants presses OK
flowScheduler.add(updateInfo); // add timeStamp
flowScheduler.add(experimentInit);
const trials_2LoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(trials_2LoopBegin(trials_2LoopScheduler));
flowScheduler.add(trials_2LoopScheduler);
flowScheduler.add(trials_2LoopEnd);
flowScheduler.add(quitPsychoJS, '', true);

// quit if user presses Cancel in dialog box:
dialogCancelScheduler.add(quitPsychoJS, '', false);

psychoJS.start({
  expName: expName,
  expInfo: expInfo,
  resources: [
    {'name': 'images/green.png', 'path': 'images/green.png'},
    {'name': 'images/Test1_Delay_A.png', 'path': 'images/Test1_Delay_A.png'},
    {'name': 'images/Red_Bottom.png', 'path': 'images/Red_Bottom.png'},
    {'name': 'images/pink.png', 'path': 'images/pink.png'},
    {'name': 'TaskList1.xlsx', 'path': 'TaskList1.xlsx'},
    {'name': 'Oneback1.xlsx', 'path': 'Oneback1.xlsx'},
    {'name': 'images/Red_Top.png', 'path': 'images/Red_Top.png'},
    {'name': 'Immed1.xlsx', 'path': 'Immed1.xlsx'},
    {'name': 'images/white.png', 'path': 'images/white.png'},
    {'name': 'Deferred1.xlsx', 'path': 'Deferred1.xlsx'},
    {'name': 'images/Test1_Delay_B.png', 'path': 'images/Test1_Delay_B.png'},
    {'name': 'images/Train_Imm_A.png', 'path': 'images/Train_Imm_A.png'},
    {'name': 'images/Test2_Defer_A.png', 'path': 'images/Test2_Defer_A.png'},
    {'name': 'images/Teal_Top.png', 'path': 'images/Teal_Top.png'},
    {'name': 'Delay1.xlsx', 'path': 'Delay1.xlsx'},
    {'name': 'images/Test2_Defer_B.png', 'path': 'images/Test2_Defer_B.png'},
    {'name': 'images/Teal_Bottom.png', 'path': 'images/Teal_Bottom.png'}
  ]
});

psychoJS.experimentLogger.setLevel(core.Logger.ServerLevel.EXP);


var frameDur;
async function updateInfo() {
  expInfo['date'] = util.MonotonicClock.getDateStr();  // add a simple timestamp
  expInfo['expName'] = expName;
  expInfo['psychopyVersion'] = '2022.1.2';
  expInfo['OS'] = window.navigator.platform;

  psychoJS.experiment.dataFileName = (("." + "/") + `data/${expInfo["participant"]}_${expName}_${expInfo["date"]}`);

  // store frame rate of monitor if we can measure it successfully
  expInfo['frameRate'] = psychoJS.window.getActualFrameRate();
  if (typeof expInfo['frameRate'] !== 'undefined')
    frameDur = 1.0 / Math.round(expInfo['frameRate']);
  else
    frameDur = 1.0 / 60.0; // couldn't get a reliable measure so guess

  // add info from the URL:
  util.addInfoFromUrl(expInfo);
  
  return Scheduler.Event.NEXT;
}


var trialClock;
var image;
var key_resp;
var A_text;
var B_text;
var feedbackClock;
var corr_history;
var score;
var trial_num;
var Feedback_img_list;
var Feedback_onset;
var show_stim;
var response;
var timeout;
var conditional;
var fdbk;
var image_2;
var def_feedbackClock;
var def1;
var def2;
var def3;
var def4;
var def5;
var def6;
var deferred_trial1;
var deferred_trial2;
var deferred_trial3;
var deferred_trial4;
var deferred_trial5;
var deferred_trial6;
var globalClock;
var routineTimer;
async function experimentInit() {
  // Initialize components for Routine "trial"
  trialClock = new util.Clock();
  image = new visual.ImageStim({
    win : psychoJS.window,
    name : 'image', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0.0, pos : [0, 0], size : [1.8, 1.3],
    color : new util.Color([1,1,1]), opacity : undefined,
    flipHoriz : false, flipVert : false,
    texRes : 128.0, interpolate : false, depth : -1.0 
  });
  key_resp = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  A_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'A_text',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.15,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('black'),  opacity: undefined,
    depth: -3.0 
  });
  
  B_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'B_text',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.15,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('black'),  opacity: undefined,
    depth: -4.0 
  });
  
  // Initialize components for Routine "feedback"
  feedbackClock = new util.Clock();
  corr_history = [];
  score = 0;
  trial_num = 0;
  Feedback_img_list = [];
  Feedback_onset = "";
  show_stim = "";
  response = "";
  timeout = 0;
  conditional = true;
  
  fdbk = new visual.TextStim({
    win: psychoJS.window,
    name: 'fdbk',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('black'),  opacity: undefined,
    depth: -1.0 
  });
  
  image_2 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'image_2', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0.0, pos : [0, 0], size : [1.8, 1.3],
    color : new util.Color([1,1,1]), opacity : undefined,
    flipHoriz : false, flipVert : false,
    texRes : 128.0, interpolate : false, depth : -2.0 
  });
  // Initialize components for Routine "def_feedback"
  def_feedbackClock = new util.Clock();
  def1 = " ";
  def2 = " ";
  def3 = " ";
  def4 = " ";
  def5 = " ";
  def6 = " ";
  
  deferred_trial1 = new visual.TextStim({
    win: psychoJS.window,
    name: 'deferred_trial1',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('black'),  opacity: undefined,
    depth: -1.0 
  });
  
  deferred_trial2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'deferred_trial2',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('black'),  opacity: undefined,
    depth: -2.0 
  });
  
  deferred_trial3 = new visual.TextStim({
    win: psychoJS.window,
    name: 'deferred_trial3',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('black'),  opacity: undefined,
    depth: -3.0 
  });
  
  deferred_trial4 = new visual.TextStim({
    win: psychoJS.window,
    name: 'deferred_trial4',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('black'),  opacity: undefined,
    depth: -4.0 
  });
  
  deferred_trial5 = new visual.TextStim({
    win: psychoJS.window,
    name: 'deferred_trial5',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('black'),  opacity: undefined,
    depth: -5.0 
  });
  
  deferred_trial6 = new visual.TextStim({
    win: psychoJS.window,
    name: 'deferred_trial6',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('black'),  opacity: undefined,
    depth: -6.0 
  });
  
  // Create some handy timers
  globalClock = new util.Clock();  // to track the time since experiment started
  routineTimer = new util.CountdownTimer();  // to track time remaining of each (non-slip) routine
  
  return Scheduler.Event.NEXT;
}


var trials_2;
var currentLoop;
function trials_2LoopBegin(trials_2LoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    trials_2 = new TrialHandler({
      psychoJS: psychoJS,
      nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: 'TaskList1.xlsx',
      seed: undefined, name: 'trials_2'
    });
    psychoJS.experiment.addLoop(trials_2); // add the loop to the experiment
    currentLoop = trials_2;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    trials_2.forEach(function() {
      const snapshot = trials_2.getSnapshot();
    
      trials_2LoopScheduler.add(importConditions(snapshot));
      const trialsLoopScheduler = new Scheduler(psychoJS);
      trials_2LoopScheduler.add(trialsLoopBegin(trialsLoopScheduler, snapshot));
      trials_2LoopScheduler.add(trialsLoopScheduler);
      trials_2LoopScheduler.add(trialsLoopEnd);
      trials_2LoopScheduler.add(endLoopIteration(trials_2LoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}


var trials;
function trialsLoopBegin(trialsLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    trials = new TrialHandler({
      psychoJS: psychoJS,
      nReps: 10, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: Task,
      seed: undefined, name: 'trials'
    });
    psychoJS.experiment.addLoop(trials); // add the loop to the experiment
    currentLoop = trials;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    trials.forEach(function() {
      const snapshot = trials.getSnapshot();
    
      trialsLoopScheduler.add(importConditions(snapshot));
      trialsLoopScheduler.add(trialRoutineBegin(snapshot));
      trialsLoopScheduler.add(trialRoutineEachFrame());
      trialsLoopScheduler.add(trialRoutineEnd());
      trialsLoopScheduler.add(feedbackRoutineBegin(snapshot));
      trialsLoopScheduler.add(feedbackRoutineEachFrame());
      trialsLoopScheduler.add(feedbackRoutineEnd());
      const defer_loopLoopScheduler = new Scheduler(psychoJS);
      trialsLoopScheduler.add(defer_loopLoopBegin(defer_loopLoopScheduler, snapshot));
      trialsLoopScheduler.add(defer_loopLoopScheduler);
      trialsLoopScheduler.add(defer_loopLoopEnd);
      trialsLoopScheduler.add(endLoopIteration(trialsLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}


var defer_loop;
function defer_loopLoopBegin(defer_loopLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    defer_loop = new TrialHandler({
      psychoJS: psychoJS,
      nReps: int(conditional), method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: undefined,
      seed: undefined, name: 'defer_loop'
    });
    psychoJS.experiment.addLoop(defer_loop); // add the loop to the experiment
    currentLoop = defer_loop;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    defer_loop.forEach(function() {
      const snapshot = defer_loop.getSnapshot();
    
      defer_loopLoopScheduler.add(importConditions(snapshot));
      defer_loopLoopScheduler.add(def_feedbackRoutineBegin(snapshot));
      defer_loopLoopScheduler.add(def_feedbackRoutineEachFrame());
      defer_loopLoopScheduler.add(def_feedbackRoutineEnd());
      defer_loopLoopScheduler.add(endLoopIteration(defer_loopLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}


async function defer_loopLoopEnd() {
  psychoJS.experiment.removeLoop(defer_loop);

  return Scheduler.Event.NEXT;
}


async function trialsLoopEnd() {
  psychoJS.experiment.removeLoop(trials);

  return Scheduler.Event.NEXT;
}


async function trials_2LoopEnd() {
  psychoJS.experiment.removeLoop(trials_2);

  return Scheduler.Event.NEXT;
}


var t;
var frameN;
var continueRoutine;
var ax;
var ay;
var bx;
var by;
var _key_resp_allKeys;
var trialComponents;
function trialRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //------Prepare to start Routine 'trial'-------
    t = 0;
    trialClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    if ((Feedback_Type === "Immediate")) {
        ax = (- 0.6);
        ay = 0.01;
        bx = (- 0.25);
        by = 0.01;
    }
    if ((Feedback_Type === "Delayed")) {
        ax = (- 0.6);
        ay = 0.01;
        bx = (- 0.25);
        by = 0.01;
    }
    if ((Feedback_Type === "Oneback")) {
        if ((Top_Bott === "Top")) {
            ax = (- 0.6);
            ay = 0.27;
            bx = (- 0.25);
            by = 0.27;
        }
        if ((Top_Bott === "Bottom")) {
            ax = (- 0.6);
            ay = (- 0.3);
            bx = (- 0.25);
            by = (- 0.3);
        }
    }
    if ((Feedback_Type === "Deferred")) {
        ax = (- 0.6);
        ay = 0.01;
        bx = (- 0.25);
        by = 0.01;
    }
    
    image.setImage(Stim);
    key_resp.keys = undefined;
    key_resp.rt = undefined;
    _key_resp_allKeys = [];
    A_text.setPos([ax, ay]);
    A_text.setText('A');
    B_text.setPos([bx, by]);
    B_text.setText('B');
    // keep track of which components have finished
    trialComponents = [];
    trialComponents.push(image);
    trialComponents.push(key_resp);
    trialComponents.push(A_text);
    trialComponents.push(B_text);
    
    trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function trialRoutineEachFrame() {
  return async function () {
    //------Loop for each frame of Routine 'trial'-------
    // get current time
    t = trialClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *image* updates
    if (t >= 0.0 && image.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      image.tStart = t;  // (not accounting for frame time here)
      image.frameNStart = frameN;  // exact frame index
      
      image.setAutoDraw(true);
    }

    
    // *key_resp* updates
    if (t >= 0.0 && key_resp.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp.tStart = t;  // (not accounting for frame time here)
      key_resp.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp.clearEvents(); });
    }

    if (key_resp.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp.getKeys({keyList: ['s', 'l'], waitRelease: false});
      _key_resp_allKeys = _key_resp_allKeys.concat(theseKeys);
      if (_key_resp_allKeys.length > 0) {
        key_resp.keys = _key_resp_allKeys[_key_resp_allKeys.length - 1].name;  // just the last key pressed
        key_resp.rt = _key_resp_allKeys[_key_resp_allKeys.length - 1].rt;
        // was this correct?
        if (key_resp.keys == Corr_Ans) {
            key_resp.corr = 1;
        } else {
            key_resp.corr = 0;
        }
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    
    // *A_text* updates
    if (t >= 0.0 && A_text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      A_text.tStart = t;  // (not accounting for frame time here)
      A_text.frameNStart = frameN;  // exact frame index
      
      A_text.setAutoDraw(true);
    }

    
    // *B_text* updates
    if (t >= 0.0 && B_text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      B_text.tStart = t;  // (not accounting for frame time here)
      B_text.frameNStart = frameN;  // exact frame index
      
      B_text.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function trialRoutineEnd() {
  return async function () {
    //------Ending Routine 'trial'-------
    trialComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // was no response the correct answer?!
    if (key_resp.keys === undefined) {
      if (['None','none',undefined].includes(Corr_Ans)) {
         key_resp.corr = 1;  // correct non-response
      } else {
         key_resp.corr = 0;  // failed to respond (incorrectly)
      }
    }
    // store data for psychoJS.experiment (ExperimentHandler)
    // update the trial handler
    if (currentLoop instanceof MultiStairHandler) {
      currentLoop.addResponse(key_resp.corr, level);
    }
    psychoJS.experiment.addData('key_resp.keys', key_resp.keys);
    psychoJS.experiment.addData('key_resp.corr', key_resp.corr);
    if (typeof key_resp.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp.rt', key_resp.rt);
        routineTimer.reset();
        }
    
    key_resp.stop();
    // the Routine "trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var feedback_onset;
var feedback_img_onset;
var feedbackComponents;
function feedbackRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //------Prepare to start Routine 'feedback'-------
    t = 0;
    feedbackClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    corr_history.push(key_resp.corr);
    Feedback_img_list.push(Feedback_img);
    trial_num = (trials.thisN + 1);
    if ((Feedback_Type === "Immediate")) {
        conditional = false;
        feedback_onset = 0;
        feedback_img_onset = 0;
        show_stim = "white.png";
        if ((corr_history.slice((- 1))[0] === 1)) {
            score = (score + 1);
            response = ("Correct +1 point. Total points: " + score.toString());
            timeout = 1.5;
        } else {
            score = (score - 1);
            response = ("Incorrect +1 point. Total points: " + score.toString());
            timeout = 4;
        }
    }
    if ((Feedback_Type === "Delayed")) {
        conditional = false;
        feedback_onset = 6;
        feedback_img_onset = 6;
        show_stim = "green.png";
        if ((corr_history.slice((- 1))[0] === 1)) {
            score = (score + 1);
            response = ("Correct +1 point. Total points: " + score.toString());
            timeout = 1.5;
        } else {
            score = (score - 1);
            response = ("Incorrect +1 point. Total points: " + score.toString());
            timeout = 4;
        }
    }
    if ((Feedback_Type === "Oneback")) {
        conditional = false;
        if ((trials.thisN === 0)) {
            response = " ";
            timeout = 0;
            feedback_onset = 0;
            if ((corr_history.slice((- 1))[0] === 1)) {
                score = (score + 1);
            } else {
                score = (score - 1);
            }
        }
        if ((trials.thisN >= 1)) {
            show_stim = Feedback_img_list.slice((- 2))[0];
            feedback_onset = 1.5;
            if ((corr_history.slice((- 2))[0] === 1)) {
                feedback_img_onset = 1.5;
                timeout = 1.5;
                score = (score + 1);
                if (((trial_num % 2) === 0)) {
                    response = ("Last TOP trial Correct +1 point. Total points: " + score.toString());
                } else {
                    response = ("Last BOTTOM trial Correct +1 point. Total points: " + score.toString());
                }
            } else {
                feedback_img_onset = 4;
                timeout = 4;
                score = (score - 1);
                if (((trial_num % 2) > 0)) {
                    response = ("Last TOP trial Incorrect -1 point. Total points: " + score.toString());
                } else {
                    response = ("Last BOTTOM trial Incorrect -1 point. Total points: " + score.toString());
                }
            }
        }
    }
    if ((Feedback_Type === "Deferred")) {
        show_stim = "pink.png";
        feedback_onset = 0;
        feedback_img_onset = 0;
        if (((trial_num % 6) === 0)) {
            conditional = true;
        } else {
            response = " ";
            timeout = 0.1;
            conditional = false;
        }
    }
    psychoJS.experiment.addData("corr_history", corr_history);
    
    fdbk.setText(response);
    image_2.setImage(show_stim);
    // keep track of which components have finished
    feedbackComponents = [];
    feedbackComponents.push(fdbk);
    feedbackComponents.push(image_2);
    
    feedbackComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


var frameRemains;
function feedbackRoutineEachFrame() {
  return async function () {
    //------Loop for each frame of Routine 'feedback'-------
    // get current time
    t = feedbackClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *fdbk* updates
    if (frameN >= feedback_onset && fdbk.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fdbk.tStart = t;  // (not accounting for frame time here)
      fdbk.frameNStart = frameN;  // exact frame index
      
      fdbk.setAutoDraw(true);
    }

    if (fdbk.status === PsychoJS.Status.STARTED && t >= (fdbk.tStart + timeout)) {
      fdbk.setAutoDraw(false);
    }
    
    // *image_2* updates
    if (t >= 0.0 && image_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      image_2.tStart = t;  // (not accounting for frame time here)
      image_2.frameNStart = frameN;  // exact frame index
      
      image_2.setAutoDraw(true);
    }

    frameRemains = 0.0 + feedback_img_onset - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (image_2.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      image_2.setAutoDraw(false);
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    feedbackComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


var last10;
var avg_acc;
function feedbackRoutineEnd() {
  return async function () {
    //------Ending Routine 'feedback'-------
    feedbackComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    last10 = corr_history.slice((- 10));
    avg_acc = (util.sum(last10) / 10);
    if (((avg_acc >= 0.8) && (trial_num >= 10))) {
        trials.finished = true;
    }
    
    // the Routine "feedback" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var def_feedbackComponents;
function def_feedbackRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //------Prepare to start Routine 'def_feedback'-------
    t = 0;
    def_feedbackClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    if ((corr_history.slice((- 6))[0] === 1)) {
        score = (score + 1);
        def1 = ("Correct +1 point. Total Points: " + score.toString());
        timeout = 1.0;
    } else {
        score = (score - 1);
        def1 = ("Incorrect -1 point. Total Points: " + score.toString());
        timeout = 4.0;
    }
    if ((corr_history.slice((- 5))[0] === 1)) {
        score = (score + 1);
        def2 = ("Correct +1 point. Total Points: " + score.toString());
        timeout = 1;
    } else {
        score = (score - 1);
        def2 = ("Incorrect -1 point. Total Points: " + score.toString());
        timeout = 4;
    }
    if ((corr_history.slice((- 4))[0] === 1)) {
        score = (score + 1);
        def3 = ("Correct +1 point. Total Points: " + score.toString());
        timeout = 1;
    } else {
        score = (score - 1);
        def3 = ("Incorrect -1 point. Total Points: " + score.toString());
        timeout = 4;
    }
    if ((corr_history.slice((- 3))[0] === 1)) {
        score = (score + 1);
        def4 = ("Correct +1 point. Total Points: " + score.toString());
        timeout = 1;
    } else {
        score = (score - 1);
        def4 = ("Incorrect -1 point. Total Points: " + score.toString());
        timeout = 4;
    }
    if ((corr_history.slice((- 2))[0] === 1)) {
        score = (score + 1);
        def5 = ("Correct +1 point. Total Points: " + score.toString());
        timeout = 1;
    } else {
        score = (score - 1);
        def5 = ("Incorrect -1 point. Total Points: " + score.toString());
        timeout = 4;
    }
    if ((corr_history.slice((- 1))[0] === 1)) {
        score = (score + 1);
        def6 = ("Correct +1 point. Total Points: " + score.toString());
        timeout = 1;
    } else {
        score = (score - 1);
        def6 = ("Incorrect -1 point. Total Points: " + score.toString());
        timeout = 4;
    }
    
    deferred_trial1.setText(def1);
    deferred_trial2.setText(def2);
    deferred_trial3.setText(def3);
    deferred_trial4.setText(def4);
    deferred_trial5.setText(def5);
    deferred_trial6.setText(def6);
    // keep track of which components have finished
    def_feedbackComponents = [];
    def_feedbackComponents.push(deferred_trial1);
    def_feedbackComponents.push(deferred_trial2);
    def_feedbackComponents.push(deferred_trial3);
    def_feedbackComponents.push(deferred_trial4);
    def_feedbackComponents.push(deferred_trial5);
    def_feedbackComponents.push(deferred_trial6);
    
    def_feedbackComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}


function def_feedbackRoutineEachFrame() {
  return async function () {
    //------Loop for each frame of Routine 'def_feedback'-------
    // get current time
    t = def_feedbackClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *deferred_trial1* updates
    if (t >= 0.0 && deferred_trial1.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      deferred_trial1.tStart = t;  // (not accounting for frame time here)
      deferred_trial1.frameNStart = frameN;  // exact frame index
      
      deferred_trial1.setAutoDraw(true);
    }

    frameRemains = 0.0 + timeout - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (deferred_trial1.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      deferred_trial1.setAutoDraw(false);
    }
    
    // *deferred_trial2* updates
    if (((deferred_trial1.status == FINISHED)) && deferred_trial2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      deferred_trial2.tStart = t;  // (not accounting for frame time here)
      deferred_trial2.frameNStart = frameN;  // exact frame index
      
      deferred_trial2.setAutoDraw(true);
    }

    if (deferred_trial2.status === PsychoJS.Status.STARTED && t >= (deferred_trial2.tStart + timeout)) {
      deferred_trial2.setAutoDraw(false);
    }
    
    // *deferred_trial3* updates
    if (((deferred_trial2.status == FINISHED)) && deferred_trial3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      deferred_trial3.tStart = t;  // (not accounting for frame time here)
      deferred_trial3.frameNStart = frameN;  // exact frame index
      
      deferred_trial3.setAutoDraw(true);
    }

    if (deferred_trial3.status === PsychoJS.Status.STARTED && t >= (deferred_trial3.tStart + timeout)) {
      deferred_trial3.setAutoDraw(false);
    }
    
    // *deferred_trial4* updates
    if (((deferred_trial3.status == FINISHED)) && deferred_trial4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      deferred_trial4.tStart = t;  // (not accounting for frame time here)
      deferred_trial4.frameNStart = frameN;  // exact frame index
      
      deferred_trial4.setAutoDraw(true);
    }

    if (deferred_trial4.status === PsychoJS.Status.STARTED && t >= (deferred_trial4.tStart + timeout)) {
      deferred_trial4.setAutoDraw(false);
    }
    
    // *deferred_trial5* updates
    if (((deferred_trial4.status == FINISHED)) && deferred_trial5.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      deferred_trial5.tStart = t;  // (not accounting for frame time here)
      deferred_trial5.frameNStart = frameN;  // exact frame index
      
      deferred_trial5.setAutoDraw(true);
    }

    if (deferred_trial5.status === PsychoJS.Status.STARTED && t >= (deferred_trial5.tStart + timeout)) {
      deferred_trial5.setAutoDraw(false);
    }
    
    // *deferred_trial6* updates
    if (((deferred_trial5.status == FINISHED)) && deferred_trial6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      deferred_trial6.tStart = t;  // (not accounting for frame time here)
      deferred_trial6.frameNStart = frameN;  // exact frame index
      
      deferred_trial6.setAutoDraw(true);
    }

    if (deferred_trial6.status === PsychoJS.Status.STARTED && t >= (deferred_trial6.tStart + timeout)) {
      deferred_trial6.setAutoDraw(false);
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    def_feedbackComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function def_feedbackRoutineEnd() {
  return async function () {
    //------Ending Routine 'def_feedback'-------
    def_feedbackComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "def_feedback" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


function endLoopIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      } else {
        const thisTrial = snapshot.getCurrentTrial();
        if (typeof thisTrial === 'undefined' || !('isTrials' in thisTrial) || thisTrial.isTrials) {
          psychoJS.experiment.nextEntry(snapshot);
        }
      }
    return Scheduler.Event.NEXT;
    }
  };
}


function importConditions(currentLoop) {
  return async function () {
    psychoJS.importAttributes(currentLoop.getCurrentTrial());
    return Scheduler.Event.NEXT;
    };
}


async function quitPsychoJS(message, isCompleted) {
  // Check for and save orphaned data
  if (psychoJS.experiment.isEntryEmpty()) {
    psychoJS.experiment.nextEntry();
  }
  
  
  
  
  
  
  
  
  
  
  
  
  psychoJS.window.close();
  psychoJS.quit({message: message, isCompleted: isCompleted});
  
  return Scheduler.Event.QUIT;
}
